

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

   variable NUM 64

   for {set i 0} {$i < $NUM} {incr i} {
       set ITEM($i) ""
       set COUNT($i) 0
       set RATE($i) 0
   }

   source [file join $env(MIDASBASE) Prospectus tcl stats.defn.tcl]



    proc do_counters {} {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetCounters} m]
        if {$rc != 0} {
            InsertLog "COUNTERS returned with an error\n$m\n$errorCode\n$errorInfo"
            set msg ""
        } else {
            set msg ""
            foreach item $m {append msg "[expr $item] "}
        }
        return $msg
    }

    proc do_rates {} {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetRates} m]
        if {$rc != 0} {
            InsertLog "RATES returned with an error\n$m\n$errorCode\n$errorInfo"
            set msg ""
        } else {
            set msg ""
            foreach item $m {append msg "[expr $item] "}
        }
        return $msg
    }


   proc  show_variables {} {

      InsertLog "COUNTERS returned [do_counters]"
      InsertLog "RATES returned [do_rates]"
 
   }


     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgiNUMdata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   DOCOUNTERS {do_counters}
                   DORATES    {do_rates}
                   DOUPDATE    {}
                   UPDATESTATS {}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

    }  ;#  end of do_click

}   ;# end of if {$started == 0}




